searchNodes=[{"doc":"Functions for interacting with sites managed by SiteEncrypt.","ref":"SiteEncrypt.html","title":"SiteEncrypt","type":"behaviour"},{"doc":"Invoked during startup to obtain certification info.See configure/1 for details.","ref":"SiteEncrypt.html#c:certification/0","title":"SiteEncrypt.certification/0","type":"callback"},{"doc":"Invoke this macro from certification/0 to return the fully shaped configuration.The minimal implementation of certification/0 looks as follows:@impl SiteEncrypt def certification do SiteEncrypt.configure( client: :native, domains: [&quot;mysite.com&quot;, &quot;www.mysite.com&quot;], emails: [&quot;contact@abc.org&quot;, &quot;another_contact@abc.org&quot;], db_folder: Application.app_dir(:phoenix_demo, Path.join(~w/priv site_encrypt/)) # set OS env var CERT_MODE to &quot;staging&quot; or &quot;production&quot; on staging/production hosts directory_url: case System.get_env(&quot;CERT_MODE&quot;, &quot;local&quot;) do &quot;local&quot; -&gt; {:internal, port: 4002} &quot;staging&quot; -&gt; &quot;https://acme-staging-v02.api.letsencrypt.org/directory&quot; &quot;production&quot; -&gt; &quot;https://acme-v02.api.letsencrypt.org/directory&quot; end ) endOptions:client - Required. Can be either :native or :certbot.The native client requires no extra OS-level dependencies, and it runs faster, which is especially useful in a local development and tests. However, this client is very immature, possibly buggy, and incomplete.The certbot client is a wrapper around the certbot tool, which has to be installed on the host machine. This client is much more reliable than the native client, but it is also significantly slower.As a compromise between these two choices, you can consider running certbot client in production and during CI tests, while using the native client for local development and local tests.:domains - Required. The list of domains for which the certificate will be obtained. Must contain at least one element.:emails - Required. The list of email addresses which will be passed to the CA when creating the new account.:db_folder - Required. The folder where site_encrypt stores its data, such as certificates and account keys.:directory_url - Required. The URL to CA directory resource. It can be either a string (e.g. &quot;https://acme-v02.api.letsencrypt.org/directory&quot;) or a tuple in the shape of {:internal, port: local_acme_server_port}. In the latter case, an internal ACME server will be started at the given port. This is useful for local development and testing.:backup - Path to the backup file. If this option is provided, site_encrypt will backup the entire content of the :db_folder to the given path after every successful certification. When the system is being started, if the backup file exists while the :db_folder is empty, the system will perform a restore. The generated file will be a zipped tarball. If this option is not provided no backup will be generated.:days_to_renew - A positive integer which determines the next renewal attempt. For example, if this value is 30, the certificate will be renewed if it expires in 30 days or less. The default value is 30.:log_level - Logger level for info messages. The default value is :info.:key_size - The size used for generating private keys. The default value is 4096.:mode - When set to :auto, the certificate will be automatically created or renewed when needed.When set to :manual, you need to start the certification manually, using functions such as SiteEncrypt.force_certify/1 or SiteEncrypt.dry_certify/2. This can be useful for the first deploy, where you want to manually test the certification. In :test mix environment the mode is always :manual. The default value is :auto.","ref":"SiteEncrypt.html#configure/1","title":"SiteEncrypt.configure/1","type":"macro"},{"doc":"Generates a new throwaway certificate for the given site.This function will perform the full certification at the given CA server. The new certificate won't be used by the site, nor stored on disk. This is mostly useful to test the certification through the staging CA server from the production server, which can be done as follows:SiteEncrypt.dry_certify( MySystemWeb.Endpoint, directory_url: &quot;https://acme-staging-v02.api.letsencrypt.org/directory&quot; )If for some reasons you want to apply the certificate to the site, you can pass the returned pems to set_certificate/2.","ref":"SiteEncrypt.html#dry_certify/2","title":"SiteEncrypt.dry_certify/2","type":"function"},{"doc":"Unconditionally obtains the new certificate for the site.Be very careful when invoking this function in production, because you might trip some rate limit at the CA server (see here for Let's Encrypt limits).","ref":"SiteEncrypt.html#force_certify/1","title":"SiteEncrypt.force_certify/1","type":"function"},{"doc":"Invoked after the new certificate has been obtained.","ref":"SiteEncrypt.html#c:handle_new_cert/0","title":"SiteEncrypt.handle_new_cert/0","type":"callback"},{"doc":"Returns the paths to the certificates and the key for the given site.","ref":"SiteEncrypt.html#https_keys/1","title":"SiteEncrypt.https_keys/1","type":"function"},{"doc":"Sets the new site certificate.This operation doesn't persist the certificate in the client storage. As a result, if the client previously obtained and stored a valid certificate, that certificate will be used after the endpoint is restarted.","ref":"SiteEncrypt.html#set_certificate/2","title":"SiteEncrypt.set_certificate/2","type":"function"},{"doc":"","ref":"SiteEncrypt.html#t:certification/0","title":"SiteEncrypt.certification/0","type":"opaque"},{"doc":"Uniquely identifies the site certified via site_encrypt.The actual value is determined by the adapter used to start the site. For example, if SiteEncrypt.Phoenix is used, the site id is the endpoint module.","ref":"SiteEncrypt.html#t:id/0","title":"SiteEncrypt.id/0","type":"type"},{"doc":"","ref":"SiteEncrypt.html#t:pems/0","title":"SiteEncrypt.pems/0","type":"type"},{"doc":"ACME related functions for endpoints managed by SiteEncrypt.This module exposes higher-level ACME client-side scenarios, such as new account creation, and certification. Normally these functions are invoked automatically by SiteEncrypt processes.The functions in this module operate on a running endpoint managed by SiteEncrypt. For Phoenix this means that the endpoint must be started through SiteEncrypt.Phoenix.See also SiteEncrypt.Acme.Client.API for details about API sessions and lower level API.","ref":"SiteEncrypt.Acme.Client.html","title":"SiteEncrypt.Acme.Client","type":"module"},{"doc":"Obtains the new certificate.The obtained certificate will not be applied to the endpoint or stored to disk. If you want to apply the new certificate to the endpoint, you can pass the returned pems to the function SiteEncrypt.set_certificate/2.","ref":"SiteEncrypt.Acme.Client.html#create_certificate/2","title":"SiteEncrypt.Acme.Client.create_certificate/2","type":"function"},{"doc":"Returns API session for the existing account.","ref":"SiteEncrypt.Acme.Client.html#for_existing_account/3","title":"SiteEncrypt.Acme.Client.for_existing_account/3","type":"function"},{"doc":"Creates the new account.","ref":"SiteEncrypt.Acme.Client.html#new_account/2","title":"SiteEncrypt.Acme.Client.new_account/2","type":"function"},{"doc":"Low level API for interacting with an ACME CA server.This module is a very incomplete implementation of the ACME client, as described in RFC8555. Internally, the module uses Mint.HTTP to communicate with the server. All functions will internally make a blocking HTTP request to the server. Therefore it's advised to invoke the functions of this module from within a separate process, powered by Task.To use the client, you first need to create the session with new_session/3. Then you can interact with the server using the remaining functions of this module. The session doesn't hold any resources open, so you can safely use it from multiple processes.","ref":"SiteEncrypt.Acme.Client.API.html","title":"SiteEncrypt.Acme.Client.API","type":"module"},{"doc":"Obtains authorization challenges from the CA.","ref":"SiteEncrypt.Acme.Client.API.html#authorization/2","title":"SiteEncrypt.Acme.Client.API.authorization/2","type":"function"},{"doc":"Returns the status and the token of the http-01 challenge.","ref":"SiteEncrypt.Acme.Client.API.html#challenge/2","title":"SiteEncrypt.Acme.Client.API.challenge/2","type":"function"},{"doc":"Obtains the key identifier of the existing account.You only need to invoke this function if the session is created using the key of the existing account.","ref":"SiteEncrypt.Acme.Client.API.html#fetch_kid/1","title":"SiteEncrypt.Acme.Client.API.fetch_kid/1","type":"function"},{"doc":"Finalizes the given order.","ref":"SiteEncrypt.Acme.Client.API.html#finalize/3","title":"SiteEncrypt.Acme.Client.API.finalize/3","type":"function"},{"doc":"Obtains the certificate and chain from a finalized order.","ref":"SiteEncrypt.Acme.Client.API.html#get_cert/2","title":"SiteEncrypt.Acme.Client.API.get_cert/2","type":"function"},{"doc":"Creates the new account at the CA server.","ref":"SiteEncrypt.Acme.Client.API.html#new_account/2","title":"SiteEncrypt.Acme.Client.API.new_account/2","type":"function"},{"doc":"Creates a new order on the CA server.","ref":"SiteEncrypt.Acme.Client.API.html#new_order/2","title":"SiteEncrypt.Acme.Client.API.new_order/2","type":"function"},{"doc":"Creates a new session to the given CA.directory_url has to point to the GET directory resource, such as https://acme-v02.api.letsencrypt.org/directory or https://acme-staging-v02.api.letsencrypt.org/directoryaccount_key is the private key of the CA account. If you want to create the new account, you need to generate this key yourself, for example withJOSE.JWK.generate_key({:rsa, _key_size = 4096})Note that this will not create the account. You need to invoke new_account/2 to do that. It is your responsibility to safely store the private key somewhere.If you want to access the existing account, you should pass the same key used for the account creation. In this case you'll usually need to invoke fetch_kid/1 to fetch the key identifier from the CA server.Note that this function will make an in-process GET HTTP request to the given directory URL.","ref":"SiteEncrypt.Acme.Client.API.html#new_session/3","title":"SiteEncrypt.Acme.Client.API.new_session/3","type":"function"},{"doc":"Obtains the status of the given order.","ref":"SiteEncrypt.Acme.Client.API.html#order_status/2","title":"SiteEncrypt.Acme.Client.API.order_status/2","type":"function"},{"doc":"","ref":"SiteEncrypt.Acme.Client.API.html#t:challenge/0","title":"SiteEncrypt.Acme.Client.API.challenge/0","type":"type"},{"doc":"","ref":"SiteEncrypt.Acme.Client.API.html#t:directory/0","title":"SiteEncrypt.Acme.Client.API.directory/0","type":"type"},{"doc":"","ref":"SiteEncrypt.Acme.Client.API.html#t:error/0","title":"SiteEncrypt.Acme.Client.API.error/0","type":"type"},{"doc":"","ref":"SiteEncrypt.Acme.Client.API.html#t:order/0","title":"SiteEncrypt.Acme.Client.API.order/0","type":"type"},{"doc":"","ref":"SiteEncrypt.Acme.Client.API.html#t:session/0","title":"SiteEncrypt.Acme.Client.API.session/0","type":"type"},{"doc":"","ref":"SiteEncrypt.Acme.Client.API.html#t:session_opts/0","title":"SiteEncrypt.Acme.Client.API.session_opts/0","type":"type"},{"doc":"","ref":"SiteEncrypt.Acme.Client.API.html#t:status/0","title":"SiteEncrypt.Acme.Client.API.status/0","type":"type"},{"doc":"SiteEncrypt adapter for Phoenix endpoints.UsageAdd use SiteEncrypt.Phoenix to your endpoint immediately after use Phoenix.EndpointConfigure https via configure_https/2.Add the implementation of SiteEncrypt.certification/0 to the endpoint (the @behaviour SiteEncrypt is injected when this module is used).","ref":"SiteEncrypt.Phoenix.html","title":"SiteEncrypt.Phoenix","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"SiteEncrypt.Phoenix.html#child_spec/1","title":"SiteEncrypt.Phoenix.child_spec/1","type":"function"},{"doc":"Merges paths to key and certificates to the :https configuration of the endpoint config.Invoke this macro from Phoenix.Endpoint.init/2 to complete the https configuration:defmodule MyEndpoint do # ... @impl Phoenix.Endpoint def init(_key, config) do # this will merge key, cert, and chain into `:https` configuration from config.exs {:ok, SiteEncrypt.Phoenix.configure_https(config)} # to completely configure https from `init/2`, invoke: # SiteEncrypt.Phoenix.configure_https(config, port: 4001, ...) end # ... endThe options are any valid adapter HTTPS options. For many great tips on configuring HTTPS for production refer to the Plug HTTPS guide.","ref":"SiteEncrypt.Phoenix.html#configure_https/2","title":"SiteEncrypt.Phoenix.configure_https/2","type":"macro"},{"doc":"Helper for testing the certification.Usagedefmodule MyEndpoint.CertificationTest do use ExUnit.Case, async: false import SiteEncrypt.Phoenix.Test test &quot;certification&quot; do clean_restart(MyEndpoint) cert = get_cert(MyEndpoint) assert cert.domains == ~w/mysite.com www.mysite.com/ end endFor this to work, you need to use the internal ACME server during tests. Refer to SiteEncrypt.configure/1 for details.Also note that this test will restart the endpoint. In addition, it will configure Phoenix to serve the traffic. Therefore, make sure you pick a different set of ports in test, if you want to be able to run the tests while the system is started.Due to endpoint being restarted, the test case has to be marked as async: false.","ref":"SiteEncrypt.Phoenix.Test.html","title":"SiteEncrypt.Phoenix.Test","type":"module"},{"doc":"Restarts the endpoint, removing all site_encrypt folders in the process.After the restart, the new certificate will be obtained.","ref":"SiteEncrypt.Phoenix.Test.html#clean_restart/1","title":"SiteEncrypt.Phoenix.Test.clean_restart/1","type":"function"},{"doc":"Obtains the certificate for the given endpoint.The certificate is obtained by establishing an SSL connection. Therefore, for this function to work, the endpoint has to be serving traffic. This will happen if you previously invoked clean_restart/1.","ref":"SiteEncrypt.Phoenix.Test.html#get_cert/1","title":"SiteEncrypt.Phoenix.Test.get_cert/1","type":"function"},{"doc":"SiteEncrypt This project aims to provide integrated certification via Let's encrypt for sites implemented in Elixir.Integrated certification means that you don't need to run any other OS process in background. Start your site for the first time, and the system will obtain the certificate, and periodically renew it before it expires.The target projects are small-to-medium Elixir based sites which don't sit behind reverse proxies such as nginx.","ref":"readme.html","title":"SiteEncrypt","type":"extras"},{"doc":"The library is tested in a simple production, where it has been constantly running since mid 2018.Native Elixir client is very new, and not considered stable. If you prefer reliable behaviour, use the Certbot client. This will require installing Certbot &gt;= 0.31The API is not stable. Expect breaking changes in the future.","ref":"readme.html#status","title":"SiteEncrypt - Status","type":"extras"},{"doc":"A basic demo Phoenix project is available here.Add the dependency to mix.exs: defmodule PhoenixDemo.Mixfile do # ... defp deps do [ # ... {:site_encrypt, &quot;~&gt; 0.3.0&quot;} ] end end Don't forget to invoke mix.deps after that.Expand your endpoint defmodule PhoenixDemo.Endpoint do # ... # add this after `use Phoenix.Endpoint` use SiteEncrypt.Phoenix # ... @impl SiteEncrypt def certification do SiteEncrypt.configure( # Note that native client is very immature. If you want a more stable behaviour, you can # provide `:certbot` instead. Note that in this case certbot needs to be installed on the # host machine. client: :native, domains: [&quot;mysite.com&quot;, &quot;www.mysite.com&quot;], emails: [&quot;contact@abc.org&quot;, &quot;another_contact@abc.org&quot;], db_folder: Application.app_dir(:phoenix_demo, Path.join(~w/priv site_encrypt/)), # set OS env var CERT_MODE to &quot;staging&quot; or &quot;production&quot; on staging/production hosts directory_url: case System.get_env(&quot;CERT_MODE&quot;, &quot;local&quot;) do &quot;local&quot; -&gt; {:internal, port: 4002} &quot;staging&quot; -&gt; &quot;https://acme-staging-v02.api.letsencrypt.org/directory&quot; &quot;production&quot; -&gt; &quot;https://acme-v02.api.letsencrypt.org/directory&quot; end ) end # ... endConfigure https: defmodule PhoenixDemo.Endpoint do # ... @impl Phoenix.Endpoint def init(_key, config) do # this will merge key, cert, and chain into `:https` configuration from config.exs {:ok, SiteEncrypt.Phoenix.configure_https(config)} # to completely configure https from `init/2`, invoke: # SiteEncrypt.Phoenix.configure_https(config, port: 4001, ...) end # ... endStart the endpoint via SiteEncrypt: defmodule PhoenixDemo.Application do use Application def start(_type, _args) do children = [{SiteEncrypt.Phoenix, PhoenixDemo.Endpoint}] opts = [strategy: :one_for_one, name: PhoenixDemo.Supervisor] Supervisor.start_link(children, opts) end # ... endOptionally add a certification test defmodule PhoenixDemo.Endpoint.CertificationTest do use ExUnit.Case, async: false import SiteEncrypt.Phoenix.Test test &quot;certification&quot; do clean_restart(PhoenixDemo.Endpoint) cert = get_cert(PhoenixDemo.Endpoint) assert cert.domains == ~w/mysite.com www.mysite.com/ end endAnd that's it! At this point you can start the system:$ iex -S mix phx.server [info] Generating a temporary self-signed certificate. This certificate will be used until a proper certificate is issued by the CA server. [info] Running PhoenixDemo.Endpoint with cowboy 2.7.0 at 0.0.0.0:4000 (http) [info] Running PhoenixDemo.Endpoint with cowboy 2.7.0 at 0.0.0.0:4001 (https) [info] Running local ACME server at port 4002 [info] Ordering a new certificate for domain mysite.com [info] New certificate for domain mysite.com obtained [info] Certificate successfully obtained!And visit your certified site at https://localhost:4001","ref":"readme.html#quick-start","title":"SiteEncrypt - Quick start","type":"extras"},{"doc":"In general, the configuration above should work out of the box in production, as long as the domain is correctly setup, and ports properly forwarded, so the HTTP site is externally available at port 80.If you want a more manual first deploy test, here's how you can do it:Explicitly set mode: :manual in certification/0. This means that the site won't automatically certify itself. However, during the first boot it will generate a self-signed certificate.Deploy the site and verify that it's externally reachable via HTTP on port 80.Start a remote iex shell session to the running system.Perform a trial certification through the staging Let's Encrypt CA: iex&gt; SiteEncrypt.dry_certify( MySystemWeb.Endpoint, directory_url: &quot;https://acme-staging-v02.api.letsencrypt.org/directory&quot; )Keep in mind that this can be only invoked in the remote iex shell session inside the running system.If the certification succeeds, the function will return the key and the certificate. These files won't be stored on disk, and they won't be used by the endpoint.If the trial certification succeeded, you can proceed to start the real certification as follows: iex&gt; SiteEncrypt.force_certify(MySystemWeb.Endpoint)Unlike the trial certification, this function will go to the CA as configured by the certification/0 callback in the endpoint. The key and the certificate files will be stored on the disk, and the site will immediately used them. Therefore, if this function succeeds, you can visit your site via HTTPS.If all went well, remove the :mode setting from the certification/0 callback and redeploy your system.Note: be careful not to invoke these functions too frequently, because you might trip some rate limit on Let's Encrypt. See here for more details.","ref":"readme.html#testing-in-production","title":"SiteEncrypt - Testing in production","type":"extras"},{"doc":"MIT","ref":"readme.html#license","title":"SiteEncrypt - License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Fixes invalid dependency requirement.","ref":"changelog.html#0-3-1","title":"Changelog - 0.3.1","type":"extras"},{"doc":"Additions and non-breaking changesExposed lower-level ACME client API functions through SiteEncrypt.Acme.Client and SiteEncrypt.Acme.Client.API.Native client keeps the history of old keys.Key size is configurable, with the default of 4096.Added support for manual production testing through SiteEncrypt.dry_certify/2. See &quot;Testing in production&quot; section in readme for details.Renewal happens at a random time of day to avoid possible spikes on CA.Breaking changesThe internal folders structure has been changed. If you're running a site_encrypt system in production and using the certbot client, you need to create the folder acme-v02.api.letsencrypt.org (assuming you're using Let's Encrypt production) under db_folder/certbot, and then recursively copy the contents of db_folder/certbot into the new folder. If you're using the native client, you don't need to do anything.","ref":"changelog.html#0-3-0","title":"Changelog - 0.3.0","type":"extras"},{"doc":"Breaking changesThe interface for writing tests has been changed. A certification test should now be written as defmodule MyEndpoint.CertificationTest do use ExUnit.Case, async: false import SiteEncrypt.Phoenix.Test test &quot;certification&quot; do clean_restart(MyEndpoint) cert = get_cert(MyEndpoint) assert cert.domains == ~w/mysite.com www.mysite.com/ end end","ref":"changelog.html#0-2-0","title":"Changelog - 0.2.0","type":"extras"},{"doc":"added a basic native ACME clientsimplified interfaceimproved testsexpanded docsThis version introduces many breaking changes. If you've been using a pre 0.1 version, here's how to upgrade your project:In your endpoint, replace @behaviour SiteEncrypt with use SiteEncrypt.PhoenixAlso in the endpoint, change the certification/0 callback to pass the options to SiteEncrypt.configure/1 instead of just returning them.Changes in options::mode is no longer supported. Manual mode will be automatically set in tests.use :domains instead of :domain and :extra_domain:ca_url has been renamed to directory_url:email has been renamed to emails and must be a list:base_folder has been renamed to :db_folder:cert_folder is no longer supported. It will chosen automatically inside the :db_folderThe internal folders structure has been changed. If you're running a site_encrypt system in production, you need to create the folder called certbot inside the :db_folder, and recurisvely copy top-level folders under :db_folder into the newly created certbot folder.If you have been using SiteEncrypt.Phoenix.Test.verify_certification for certification testing, drop that test, and add the following module somewhere in your test suite: defmodule CertificationTest do use SiteEncrypt.Phoenix.Test, endpoint: MyEndpoint end","ref":"changelog.html#0-1-0","title":"Changelog - 0.1.0","type":"extras"}]